package uk.co.petertribble.picl;

import javax.swing.*;
import java.awt.event.*;
import uk.co.petertribble.jingle.JingleMultiFrame;
import uk.co.petertribble.jingle.JingleInfoFrame;

class JPiclBrowser extends JFrame implements ActionListener {

    JPiclTreePanel jlp;

    JMenuItem exitItem;
    JMenuItem cloneItem;
    JMenuItem closeItem;
    JMenuItem updateThisItem;
    JMenuItem helpItem;

    public JPiclBrowser() {
	addWindowListener(new winExit());
	jlp = new JPiclTreePanel();
	getContentPane().add(jlp);

	JMenuBar jm = new JMenuBar();

	// FIXME - cloning the window creates a SEGV
	// so it's disabled
	JMenu jme = new JMenu("File");
	jme.setMnemonic(KeyEvent.VK_F);
	// cloneItem = new JMenuItem("New Browser", KeyEvent.VK_B);
	// cloneItem.addActionListener(this);
	// jme.add(cloneItem);
	closeItem = new JMenuItem("Close Window", KeyEvent.VK_W);
	// closeItem.addActionListener(this);
	// jme.add(closeItem);
	exitItem = new JMenuItem("Exit", KeyEvent.VK_X);
	exitItem.addActionListener(this);
	jme.add(exitItem);

	JingleMultiFrame.register(this, closeItem);

	JMenu jmu = new JMenu("Update");
	jmu.setMnemonic(KeyEvent.VK_U);
	updateThisItem = new JMenuItem("This", KeyEvent.VK_T);
	updateThisItem.addActionListener(this);
	jmu.add(updateThisItem);

	JMenu jmh = new JMenu("Help");
	jmh.setMnemonic(KeyEvent.VK_H);
	helpItem = new JMenuItem("About piclbrowser", KeyEvent.VK_A);
	helpItem.addActionListener(this);
	jmh.add(helpItem);

	jm.add(jme);
	jm.add(jmu);
	jm.add(jmh);

	setJMenuBar(jm);

	setSize(600, 400);
	setVisible(true);
    }

    class winExit extends WindowAdapter {
	public void windowClosing(WindowEvent we) {
	    JingleMultiFrame.unregister(JPiclBrowser.this);
	}
    }

    public void actionPerformed(ActionEvent e) {
	if (e.getSource() == cloneItem) {
	    new JPiclBrowser();
	}
	if (e.getSource() == closeItem) {
	    JingleMultiFrame.unregister(this);
	}
	if (e.getSource() == exitItem) {
	    System.exit(0);
	}
	if (e.getSource() == updateThisItem) {
	    jlp.updateVisible();
	}
	if (e.getSource() == helpItem) {
	    new JingleInfoFrame(this.getClass().getClassLoader(),
			"help/index.html", "text/html");
	}
    }

    public static void main(String[] args) {
	new JPiclBrowser();
    }
}
