package uk.co.petertribble.picl;

import java.util.List;
import javax.swing.tree.DefaultMutableTreeNode;

/**
 * Java interface to Solaris PICL data.
 * Simply specifies an enumeration and lookup mechanism.
 */
public class JPiclTreeNode extends DefaultMutableTreeNode {

    private PiclObject piclobject;
    private List <PiclObject> piclnodes;

    public JPiclTreeNode(PiclObject piclobject) {
	this.piclobject = piclobject;
	setUserObject(piclobject);
	piclnodes = piclobject.getChildren();
	for (PiclObject po : piclnodes) {
	    add(new JPiclTreeNode(po));
	}
    }

    public boolean getAllowsChildren() {
	return !piclnodes.isEmpty();
    }

    public boolean isLeaf() {
	return piclnodes.isEmpty();
    }

    public String toString() {
	return piclobject.toString();
    }
}
