package uk.co.petertribble.picl;

import javax.swing.*;
import java.awt.BorderLayout;
import javax.swing.event.TreeSelectionListener;
import javax.swing.event.TreeSelectionEvent;

public class JPiclTreePanel extends JPanel {

    private JEditorPane tp;

    public JPiclTreePanel() {
	PiclObject po = new PiclObject();
	po.enumerate();
	buildpanel(po);
    }

    public JPiclTreePanel(PiclObject po) {
	buildpanel(po);
    }

    private void buildpanel(PiclObject po) {
	setLayout(new BorderLayout());

	JTabbedPane jtp = new JTabbedPane();

	final JPiclTree jpt = new JPiclTree(po);
	jtp.add("Tree", new JScrollPane(jpt));
	jpt.addTreeSelectionListener(new TreeSelectionListener() {
	    public void valueChanged(TreeSelectionEvent e) {
		setPanelText((JPiclTreeNode)
			jpt.getLastSelectedPathComponent());
	    }
	});

	// text panel on right
	tp = new JEditorPane();
	tp.setContentType("text/html");

	// right hand panel to hold text panel and accessory widget
	JPanel rpanel = new JPanel(new BorderLayout());
	rpanel.add(new JScrollPane(tp));

	// split pane to hold the lot
	JSplitPane psplit = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT, jtp,
					rpanel);
	psplit.setOneTouchExpandable(true);
	psplit.setDividerLocation(180);
	add(psplit);

    }

    private void setPanelText(JPiclTreeNode jptn) {
	tp.setText(JPiclHtml.nodeHtml(jptn));
    }

    public void updateVisible() {
	// FIXME implement
    }
}
